import { Injectable } from "@angular/core";
import { Observable } from "rxjs/Observable";
import { Observer } from "rxjs/Observer";
import { OdooRPCService } from "angular2-odoo-jsonrpc";

import 'rxjs/add/observable/throw'
import "rxjs/add/observable/fromPromise";

@Injectable()
export class AuthService {

    constructor(
        public odooRPC: OdooRPCService
    ) { }

    /**
     *
     */
    initialize(url: string, port?: number) {
        let host = url;

        if (port) {
            host = host + ":" + port;
        }
        
        this.odooRPC.init({
            odoo_server: host,
            http_auth: "username:password"
        });
    }

    /**
     *
     */
    login(database: string, username: string, password: string): Observable<any> {
        return Observable.fromPromise(this.odooRPC.login(database, username, password));
    }

    /**
     *
     */
    logout(): Observable<any> {
        return Observable.fromPromise(this.odooRPC.logout());
    }
}